--
-- Name: Camera
-- Description: Camera enhancements for steerables
-- Version: 1.0
-- Author: Saracaen
-- Date: 24/07/2011
--

Camera = {};

-- Extended original functions --
function Camera:load(xmlFile)
	
	self.isCameraEnabled = Utils.getNoNil(getXMLBool(xmlFile, "vehicle.features#camera"), true);

end;

Steerable.load = Utils.appendedFunction(Steerable.load, Camera.load);

function Camera:update(dt)

	if self.isCameraEnabled then
		if self:getIsActiveForInput() then
			if InputBinding.hasEvent(InputBinding.CAMERA_ROTATE) then
				local cam = self.cameras[self.camIndex];
				if cam.rotY >= cam.origRotY - Utils.degToRad(90) and cam.rotY <= cam.origRotY + Utils.degToRad(90) then
					self.cameras[self.camIndex].rotX = cam.origRotX;
					self.cameras[self.camIndex].rotY = cam.origRotY + Utils.degToRad(180);
				else
					self.cameras[self.camIndex].rotX = cam.origRotX;
					self.cameras[self.camIndex].rotY = cam.origRotY;
				end;
			end;
		end;
	end;

end;

Steerable.update = Utils.appendedFunction(Steerable.update, Camera.update);

function Camera:draw()

	if self.isCameraEnabled then
		if self.isClient then
			g_currentMission:addHelpButtonText(g_i18n:getText("Rotate_camera"), InputBinding.CAMERA_ROTATE);
		end;
	end;

end;

Steerable.draw = Utils.appendedFunction(Steerable.draw, Camera.draw);